/* 
 * $TSUKUBA_Release: Omni OpenMP/XcalableMP Compiler Software Version 0.5.1 $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the files named
 *  COPYRIGHT and LICENSE under the top  directory of the Omni Compiler
 *  Software release kit.
 *  
 *  * The specification of XcalableMP has been designed by the XcalableMP
 *    Specification Working Group (http://www.xcalablemp.org/).
 *  
 *  * The development of this software is supported by "Seamless and
 *    Highly-productive Parallel Programming Environment for
 *    High-performance computing" project funded by Ministry of Education,
 *    Culture, Sports, Science and Technology, Japan.
 *  $
 */
package exc.xcodeml;

import xcodeml.XmObj;
import xcodeml.c.binding.gen.XbcId;
import xcodeml.c.util.XmcSymbolUtil;
import xcodeml.f.binding.gen.XbfId;
import xcodeml.f.util.XmfSymbolUtil;
import xcodeml.util.XmOption;

public class XmSymbolUtil
{
    /**
     * find symbol in specified context.
     */
    public static XmSymbol lookupSymbol(XmObj context, String name)
    {
        if(name == null) {
            throw new NullPointerException("name is null");
        }
        
        XmSymbol symbol = null;
        XbcId xcid = null;
        XbfId xfid = null;
        
        switch(XmOption.getLanguage()) {
        case C:
            xcid = XmcSymbolUtil.lookupSymbol(context, name);
            if(xcid != null) {
                symbol = new XmSymbol(xcid);
            }
            break;
        case F:
            xfid = XmfSymbolUtil.lookupSymbol(context, name);
            if(xfid != null) {
                symbol = new XmSymbol(xfid);
            }
            break;
        }
        
        return symbol;
    }
}
